Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1319)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1320)
@@ -2719,21 +2978,64 @@
     SUBROUTINE advec_u_ws
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0
+           
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  hom, sums_us2_ws_l, sums_wsus_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit9, ibit10, ibit11, ibit12, ibit13, ibit14, ibit15,   &
-                   ibit16, ibit17, j, k, k_mm, k_pp, k_ppp, tn = 0
-       REAL    ::  diss_d, div, flux_d, gu, gv, v_comp, w_comp
-       REAL, DIMENSION(nzb+1:nzt) :: swap_diss_y_local_u, swap_flux_y_local_u
-       REAL, DIMENSION(nzb+1:nzt,nys:nyn) :: swap_diss_x_local_u,              &
-                                             swap_flux_x_local_u
-       REAL, DIMENSION(nzb:nzt) :: diss_n, diss_r, diss_t, flux_n, flux_r,     &
-                                   flux_t, u_comp
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit9  !:
+       INTEGER(iwp) ::  ibit10 !:
+       INTEGER(iwp) ::  ibit11 !:
+       INTEGER(iwp) ::  ibit12 !:
+       INTEGER(iwp) ::  ibit13 !:
+       INTEGER(iwp) ::  ibit14 !:
+       INTEGER(iwp) ::  ibit15 !:
+       INTEGER(iwp) ::  ibit16 !:
+       INTEGER(iwp) ::  ibit17 !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+       
+       REAL(wp)    ::  diss_d !:
+       REAL(wp)    ::  div    !:
+       REAL(wp)    ::  flux_d !:
+       REAL(wp)    ::  gu     !:
+       REAL(wp)    ::  gv     !:
+       REAL(wp)    ::  v_comp !:
+       REAL(wp)    ::  w_comp !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local_u !:
+       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local_u !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_u !:
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_u !:
+       
+       REAL(wp), DIMENSION(nzb:nzt) ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  flux_t !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  u_comp !:
  
        gu = 2.0 * u_gtrans
@@ -3137,19 +3439,65 @@
     SUBROUTINE advec_u_ws_acc
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxr, nyn, nys, nzb,  &
+                  nzb_max, nzt, wall_flags_0
+           
+       USE kinds
+       
+!        USE statistics,                                                       &
+!            ONLY:  hom, sums_us2_ws_l, sums_wsus_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit9, ibit10, ibit11, ibit12, ibit13, ibit14, ibit15,   &
-                   ibit16, ibit17, j, k, k_mmm, k_mm, k_pp, k_ppp, tn = 0
-
-       REAL    ::  diss_d, diss_l, diss_n, diss_r, diss_s, diss_t, div,    &
-                   flux_d, flux_l, flux_n, flux_r, flux_s, flux_t, gu, gv, &
-                   u_comp, u_comp_l, v_comp, v_comp_s, w_comp
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit9  !:
+       INTEGER(iwp) ::  ibit10 !:
+       INTEGER(iwp) ::  ibit11 !:
+       INTEGER(iwp) ::  ibit12 !:
+       INTEGER(iwp) ::  ibit13 !:
+       INTEGER(iwp) ::  ibit14 !:
+       INTEGER(iwp) ::  ibit15 !:
+       INTEGER(iwp) ::  ibit16 !:
+       INTEGER(iwp) ::  ibit17 !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mmm  !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+
+       REAL(wp)    ::  diss_d   !:
+       REAL(wp)    ::  diss_l   !:
+       REAL(wp)    ::  diss_n   !:
+       REAL(wp)    ::  diss_r   !:
+       REAL(wp)    ::  diss_s   !:
+       REAL(wp)    ::  diss_t   !:
+       REAL(wp)    ::  div      !:
+       REAL(wp)    ::  flux_d   !:
+       REAL(wp)    ::  flux_l   !:
+       REAL(wp)    ::  flux_n   !:
+       REAL(wp)    ::  flux_r   !:
+       REAL(wp)    ::  flux_s   !:
+       REAL(wp)    ::  flux_t   !:
+       REAL(wp)    ::  gu       !:
+       REAL(wp)    ::  gv       !:
+       REAL(wp)    ::  u_comp   !:
+       REAL(wp)    ::  u_comp_l !:
+       REAL(wp)    ::  v_comp   !:
+       REAL(wp)    ::  v_comp_s !:
+       REAL(wp)    ::  w_comp   !:
 
 
@@ -3424,22 +3772,65 @@
     SUBROUTINE advec_v_ws
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_max, nzt, wall_flags_0
+
+       USE kinds
+
+       USE statistics,                                                         &
+           ONLY:  hom, sums_vs2_ws_l, sums_wsvs_ws_l, weight_substep
 
        IMPLICIT NONE
 
 
-       INTEGER ::  i, ibit18, ibit19, ibit20, ibit21, ibit22, ibit23, ibit24, &
-                    ibit25, ibit26, j, k, k_mm, k_pp, k_ppp, tn = 0
-       REAL    ::  diss_d, div, flux_d, gu, gv, u_comp, w_comp
-       REAL, DIMENSION(nzb+1:nzt) :: swap_diss_y_local_v, swap_flux_y_local_v
-       REAL, DIMENSION(nzb+1:nzt,nys:nyn) :: swap_diss_x_local_v,             &
-                                             swap_flux_x_local_v
-       REAL, DIMENSION(nzb:nzt) :: diss_n, diss_r, diss_t, flux_n, flux_r,    &
-                                   flux_t, v_comp
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit18 !:
+       INTEGER(iwp) ::  ibit19 !:
+       INTEGER(iwp) ::  ibit20 !:
+       INTEGER(iwp) ::  ibit21 !:
+       INTEGER(iwp) ::  ibit22 !:
+       INTEGER(iwp) ::  ibit23 !:
+       INTEGER(iwp) ::  ibit24 !:
+       INTEGER(iwp) ::  ibit25 !:
+       INTEGER(iwp) ::  ibit26 !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+       
+       REAL(wp)    ::  diss_d !:
+       REAL(wp)    ::  div    !:
+       REAL(wp)    ::  flux_d !:
+       REAL(wp)    ::  gu     !:
+       REAL(wp)    ::  gv     !:
+       REAL(wp)    ::  u_comp !:
+       REAL(wp)    ::  w_comp !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local_v !:
+       REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local_v !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_v !:
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_v !:
+       
+       REAL(wp), DIMENSION(nzb:nzt) ::  diss_n !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  diss_r !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  flux_n !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  flux_r !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  flux_t !:
+       REAL(wp), DIMENSION(nzb:nzt) ::  v_comp !:
 
        gu = 2.0 * u_gtrans
@@ -3852,20 +4243,66 @@
     SUBROUTINE advec_v_ws_acc
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxr, nyn, nys, nzb,  &
+                  nzb_max, nzt, wall_flags_0
+           
+       USE kinds
+       
+!        USE statistics,                                                       &
+!            ONLY:  hom, sums_vs2_ws_l, sums_wsvs_ws_l, weight_substep
 
        IMPLICIT NONE
 
 
-       INTEGER ::  i, ibit18, ibit19, ibit20, ibit21, ibit22, ibit23, ibit24, &
-                    ibit25, ibit26, j, k, k_mm, k_mmm, k_pp, k_ppp, tn = 0
-
-       REAL    ::  diss_d, diss_l, diss_n, diss_r, diss_s, diss_t, div,    &
-                   flux_d, flux_l, flux_n, flux_r, flux_s, flux_t, gu, gv, &
-                   u_comp, u_comp_l, v_comp, v_comp_s, w_comp
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit18 !:
+       INTEGER(iwp) ::  ibit19 !:
+       INTEGER(iwp) ::  ibit20 !:
+       INTEGER(iwp) ::  ibit21 !:
+       INTEGER(iwp) ::  ibit22 !:
+       INTEGER(iwp) ::  ibit23 !:
+       INTEGER(iwp) ::  ibit24 !:
+       INTEGER(iwp) ::  ibit25 !:
+       INTEGER(iwp) ::  ibit26 !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_mmm  !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+
+       REAL(wp)    ::  diss_d   !:
+       REAL(wp)    ::  diss_l   !:
+       REAL(wp)    ::  diss_n   !:
+       REAL(wp)    ::  diss_r   !:
+       REAL(wp)    ::  diss_s   !:
+       REAL(wp)    ::  diss_t   !:
+       REAL(wp)    ::  div      !:
+       REAL(wp)    ::  flux_d   !:
+       REAL(wp)    ::  flux_l   !:
+       REAL(wp)    ::  flux_n   !:
+       REAL(wp)    ::  flux_r   !:
+       REAL(wp)    ::  flux_s   !:
+       REAL(wp)    ::  flux_t   !:
+       REAL(wp)    ::  gu       !:
+       REAL(wp)    ::  gv       !:
+       REAL(wp)    ::  u_comp   !:
+       REAL(wp)    ::  u_comp_l !:
+       REAL(wp)    ::  v_comp   !:
+       REAL(wp)    ::  v_comp_s !:
+       REAL(wp)    ::  w_comp   !:
 
        gu = 2.0 * u_gtrans
@@ -4141,22 +4578,65 @@
     SUBROUTINE advec_w_ws
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_max, nzt, wall_flags_0,         &
+                  wall_flags_00
+
+       USE kinds
+       
+       USE statistics,                                                         &
+           ONLY:  hom, sums_ws2_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit27, ibit28, ibit29, ibit30, ibit31, ibit32, ibit33, &
-                   ibit34, ibit35, j, k, k_mm, k_pp, k_ppp, tn = 0
-       REAL    ::  diss_d, div, flux_d, gu, gv, u_comp, v_comp, w_comp
-       REAL, DIMENSION(nzb:nzt)    ::  diss_t, flux_t
-       REAL, DIMENSION(nzb+1:nzt)  ::  diss_n, diss_r, flux_n, flux_r,        &
-                                       swap_diss_y_local_w,                   &
-                                       swap_flux_y_local_w
-       REAL, DIMENSION(nzb+1:nzt,nys:nyn) :: swap_diss_x_local_w,             &
-                                             swap_flux_x_local_w
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit27 !:
+       INTEGER(iwp) ::  ibit28 !:
+       INTEGER(iwp) ::  ibit29 !:
+       INTEGER(iwp) ::  ibit30 !:
+       INTEGER(iwp) ::  ibit31 !:
+       INTEGER(iwp) ::  ibit32 !:
+       INTEGER(iwp) ::  ibit33 !:
+       INTEGER(iwp) ::  ibit34 !:
+       INTEGER(iwp) ::  ibit35 !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+       
+       REAL(wp)    ::  diss_d !:
+       REAL(wp)    ::  div    !:
+       REAL(wp)    ::  flux_d !:
+       REAL(wp)    ::  gu     !:
+       REAL(wp)    ::  gv     !:
+       REAL(wp)    ::  u_comp !:
+       REAL(wp)    ::  v_comp !:
+       REAL(wp)    ::  w_comp !:
+       
+       REAL(wp), DIMENSION(nzb:nzt)    ::  diss_t !:
+       REAL(wp), DIMENSION(nzb:nzt)    ::  flux_t !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt)  ::  diss_n !:
+       REAL(wp), DIMENSION(nzb+1:nzt)  ::  diss_r !:
+       REAL(wp), DIMENSION(nzb+1:nzt)  ::  flux_n !:
+       REAL(wp), DIMENSION(nzb+1:nzt)  ::  flux_r !:
+       REAL(wp), DIMENSION(nzb+1:nzt)  ::  swap_diss_y_local_w !:
+       REAL(wp), DIMENSION(nzb+1:nzt)  ::  swap_flux_y_local_w !:
+       
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_w !:
+       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_w !:
  
        gu = 2.0 * u_gtrans
@@ -4546,19 +5026,65 @@
     SUBROUTINE advec_w_ws_acc
 
-       USE arrays_3d
-       USE constants
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu, tend, u, v, w
+
+       USE constants,                                                          &
+           ONLY:  adv_mom_1, adv_mom_3, adv_mom_5
+
+       USE control_parameters,                                                 &
+           ONLY:  intermediate_timestep_count, u_gtrans, v_gtrans
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy
+
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxr, nyn, nys, nzb,  &
+                  nzb_max, nzt, wall_flags_0, wall_flags_00
+           
+       USE kinds
+       
+!        USE statistics,                                                       &
+!            ONLY:  hom, sums_ws2_ws_l, weight_substep
 
        IMPLICIT NONE
 
-       INTEGER ::  i, ibit27, ibit28, ibit29, ibit30, ibit31, ibit32, ibit33, &
-                   ibit34, ibit35, j, k, k_mmm, k_mm, k_pp, k_ppp, tn = 0
-
-       REAL    ::  diss_d, diss_l, diss_n, diss_r, diss_s, diss_t, div,    &
-                   flux_d, flux_l, flux_n, flux_r, flux_s, flux_t, gu, gv, &
-                   u_comp, u_comp_l, v_comp, v_comp_s, w_comp
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  ibit27 !:
+       INTEGER(iwp) ::  ibit28 !:
+       INTEGER(iwp) ::  ibit29 !:
+       INTEGER(iwp) ::  ibit30 !:
+       INTEGER(iwp) ::  ibit31 !:
+       INTEGER(iwp) ::  ibit32 !:
+       INTEGER(iwp) ::  ibit33 !:
+       INTEGER(iwp) ::  ibit34 !:
+       INTEGER(iwp) ::  ibit35 !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  k      !:
+       INTEGER(iwp) ::  k_mmm  !:
+       INTEGER(iwp) ::  k_mm   !:
+       INTEGER(iwp) ::  k_pp   !:
+       INTEGER(iwp) ::  k_ppp  !:
+       INTEGER(iwp) ::  tn = 0 !:
+
+       REAL(wp)    ::  diss_d   !:
+       REAL(wp)    ::  diss_l   !:
+       REAL(wp)    ::  diss_n   !:
+       REAL(wp)    ::  diss_r   !:
+       REAL(wp)    ::  diss_s   !:
+       REAL(wp)    ::  diss_t   !:
+       REAL(wp)    ::  div      !:
+       REAL(wp)    ::  flux_d   !:
+       REAL(wp)    ::  flux_l   !:
+       REAL(wp)    ::  flux_n   !:
+       REAL(wp)    ::  flux_r   !:
+       REAL(wp)    ::  flux_s   !:
+       REAL(wp)    ::  flux_t   !:
+       REAL(wp)    ::  gu       !:
+       REAL(wp)    ::  gv       !:
+       REAL(wp)    ::  u_comp   !:
+       REAL(wp)    ::  u_comp_l !:
+       REAL(wp)    ::  v_comp   !:
+       REAL(wp)    ::  v_comp_s !:
+       REAL(wp)    ::  w_comp   !:
 
        gu = 2.0 * u_gtrans
Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 1319)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -41,21 +46,4 @@
 ! 978 2012-08-09 08:28:32Z fricke
 ! +z0h_av
-!
-! 771 2011-10-27 10:56:21Z heinze
-! +lpt_av
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 367 2009-08-25 08:35:52Z maronga
-! Added calculation of shf* and qsws*
-!
-! 96 2007-06-04 08:07:41Z raasch
-! Averaging of density and salinity
-!
-! 72 2007-03-19 08:20:46Z raasch
-! Averaging the precipitation rate and roughness length (prr*, z0*)
-!
-! RCS Log replace by Id keyword, revision history cleaned up
 !
 ! Revision 1.1  2006/02/23 09:48:58  raasch
@@ -68,14 +56,24 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
     USE averaging
-    USE cloud_parameters
-    USE control_parameters
-    USE cpulog
-    USE indices
+
+    USE control_parameters,                                                    &
+        ONLY:  average_count_3d, doav, doav_n
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+
+    USE kinds
+
 
     IMPLICIT NONE
 
-    INTEGER ::  i, ii, j, k
+    INTEGER(iwp) ::  i  !:
+    INTEGER(iwp) ::  ii !:
+    INTEGER(iwp) ::  j  !:
+    INTEGER(iwp) ::  k  !:
 
 
@@ -165,5 +163,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   precipitation_rate_av(j,i) = precipitation_rate_av(j,i) / &
+                   precipitation_rate_av(j,i) = precipitation_rate_av(j,i) /   &
                                                 REAL( average_count_3d )
                 ENDDO
@@ -228,5 +226,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      ql_vp_av(k,j,i) = ql_vp_av(k,j,i) / &
+                      ql_vp_av(k,j,i) = ql_vp_av(k,j,i) /                      &
                                         REAL( average_count_3d )
                    ENDDO
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 1319)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !  
 ! Former revisions:
@@ -67,40 +72,4 @@
 ! 875 2012-04-02 15:35:15Z gryschka
 ! Bugfix in case of dirichlet inflow bc at the right or north boundary
-!
-! 767 2011-10-14 06:39:12Z raasch
-! ug,vg replaced by u_init,v_init as the Dirichlet top boundary condition
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-! Removed mirror boundary conditions for u and v at the bottom in case of 
-! ibc_uv_b == 0. Instead, dirichelt boundary conditions (u=v=0) are set
-! in init_3d_model 
-!
-! 107 2007-08-17 13:54:45Z raasch
-! Boundary conditions for temperature adjusted for coupled runs,
-! bugfixes for the radiation boundary conditions at the outflow: radiation
-! conditions are used for every substep, phase speeds are calculated for the
-! first Runge-Kutta substep only and then reused, several index values changed
-!
-! 95 2007-06-02 16:48:38Z raasch
-! Boundary conditions for salinity added
-!
-! 75 2007-03-22 09:54:05Z raasch
-! The "main" part sets conditions for time level t+dt instead of level t,
-! outflow boundary conditions changed from Neumann to radiation condition,
-! uxrp, vynp eliminated, moisture renamed humidity
-!
-! 19 2007-02-23 04:53:48Z raasch
-! Boundary conditions for e(nzt), pt(nzt), and q(nzt) removed because these
-! gridpoints are now calculated by the prognostic equation,
-! Dirichlet and zero gradient condition for pt established at top boundary
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.15  2006/02/23 09:54:55  raasch
-! Surface boundary conditions in case of topography: nzb replaced by
-! 2d-k-index-arrays (nzb_w_inner, etc.). Conditions for u and v remain
-! unchanged (still using nzb) because a non-flat topography must use a
-! Prandtl-layer, which don't requires explicit setting of the surface values.
 !
 ! Revision 1.1  1997/09/12 06:21:34  raasch
@@ -117,15 +86,40 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  c_u, c_u_m, c_u_m_l, c_v, c_v_m, c_v_m_l, c_w, c_w_m, c_w_m_l,  &
+               dzu, e_p, nr_p, pt, pt_p, q, q_p, qr_p, sa, sa_p,               &
+               u, ug, u_init, u_m_l, u_m_n, u_m_r, u_m_s, u_p,                 &
+               v, vg, v_init, v_m_l, v_m_n, v_m_r, v_m_s, v_p,                 &
+               w, w_p, w_m_l, w_m_n, w_m_r, w_m_s
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_pt_t_val, bc_q_t_val, constant_diffusion,                    &
+               cloud_physics, dt_3d, humidity,                                 &
+               ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_sa_t, ibc_uv_b, ibc_uv_t,      &
+               icloud_scheme, inflow_l, inflow_n, inflow_r, inflow_s,          &
+               intermediate_timestep_count, large_scale_forcing, ocean,        &
+               outflow_l, outflow_n, outflow_r, outflow_s, passive_scalar,     &
+               precipitation, tsc, use_cmax
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy, dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,             &
+               nzb, nzb_s_inner, nzb_w_inner, nzt
+
+    USE kinds
+
     USE pegrid
 
+
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
-
-    REAL    ::  c_max, denom
+    INTEGER(iwp) ::  i !:
+    INTEGER(iwp) ::  j !:
+    INTEGER(iwp) ::  k !:
+
+    REAL(wp)    ::  c_max !:
+    REAL(wp)    ::  denom !:
 
 
@@ -271,5 +265,5 @@
        q_p(nzt+1,:,:) = q_p(nzt,:,:)   + bc_q_t_val * dzu(nzt+1)
 
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                    &
             precipitation )  THEN
 !             
@@ -312,5 +306,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q_p(:,nys-1,:) = q_p(:,nys,:)
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation)  THEN
                 qr_p(:,nys-1,:) = qr_p(:,nys,:)
@@ -323,5 +317,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q_p(:,nyn+1,:) = q_p(:,nyn,:)
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
                 qr_p(:,nyn+1,:) = qr_p(:,nyn,:)
@@ -334,5 +328,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q_p(:,:,nxl-1) = q_p(:,:,nxl)
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
                 qr_p(:,:,nxl-1) = qr_p(:,:,nxl)
